<?php
// www.p30vel.ir is the Best Publisher 
if(!defined("access")){die();}
Class Login{
	
	//account username
	private $username;
	//account password
	private $password;
	
	//errors we will be showing to the user
	private $error = '';
	//which field have errors so they get a red border
	private $error_fields = '';
	
	/* Initializes and assigns the variables needed
	 * trims and escapes the variables
	*/
	function __construct($data){
		$misc = new Misc();
		foreach ($data as $id => $val){
			//assign each item to its variable
			$this->$id = $misc->escapeValue($misc->trimValue($val));//remove all spaces and escape them
		}
	}
	
	/* Checks if the data that we entered are correct
	 * and returns errors if they are not correct, if they are correct it also checks
	 * for the account if its activated, if it is then the user logs in.. if not it throws an error
	 * if they are correct
	*/
	private function checkUserCredentials(){
		$misc = new Misc();
		//find the user with the username the user entered
		$q = mysql_query("SELECT * FROM users WHERE user_name='$this->username'");
		$rows = mysql_num_rows($q);
		//if found something
		if ($rows){
			//fetch the data
			$numrows = mysql_fetch_array($q);
			$activated = $numrows["user_activated"];
			if ($activated == 1){
				//md5 the password i entered
				$password = md5($this->password);
				//get the users password from the database
				$db_pass = $numrows["user_password"];
				//if they are equal, then log the user in
				if ($password == $db_pass){
					//set the session which we will later use to identify if a user is online or not
					$_SESSION["username"] = $this->username;
					$data = $misc->getUserData($this->username);
					$_SESSION["email"] = $data["email"];
					$_SESSION["user_id"] = $data["user_id"];
				}else{
					$this->error .= '<li>Your password is incorrect.</li>';
					$this->error_fields .= 'password';
				}
			}else{
				if ($misc->approve_accounts == true){
					$this->error .= '<li>Admin must approve the accounts first before you can log in.</li>';
					$this->error_fields .= 'username, password';
				}else{
					$this->error .= '<li>This account is not activated.</li>';
					$this->error_fields .= 'username, password';
				}
			}
		}else{
			$this->error .= '<li>We couldnt find any account associated with these details.</li>';
			$this->error_fields .= 'username,password';
		}
	}
	
	/* Checks for empty data and returns errors or
	 * success message to user
	*/
	public function LoginUser(){
		//if we didnt enter nothing
		if ($this->username != "" && $this->password != ""){
			//check if the account exist and log in user, otherwise throw error
			$this->checkUserCredentials();
		}else{
			//all fields are blank, tell the user to fill them.
			$this->error .= '<li>Please fill in all fields.</li>';
			//red marked fields
			$this->error_fields .= 'username,password';
		}
		
		//no errors for sure(hopefully)
		if ($this->error == ""){
			//send user a message that the user is logged in
			$array = array(
				'error' => false,
				'message' => 'Successfully logged in.',
				'inputs_errors' => '',
				'logged_in' => true
			);
		}else{
			//else send the errors
			$array = array(
				'error' => true,
				'message' => '<ul style="padding:0;margin:0;margin-left:15px;">'.$this->error.'</ul>',
				'inputs_errors' => $this->error_fields,
				'logged_in' => false
			);
		}
		return $array;
	}
	
}
?>