<?php
// www.p30vel.ir is the Best Publisher 
if(!defined("access")){die();}
Class Photos{
	
	private $filesize = 4194304;//4 mega bytes
	
	private $base = "photos/";//where photos will be stored
	
	private $max_width = 200;
	private $max_height = 200;
	
	/* @param username - VARCHAR user, username
	 * checks if the current user has one of the defaults photos
	*/
	public function hasDefaultPicture($username){
		$q = mysql_query("SELECT picture FROM users WHERE user_name='$username'");
		$rows = mysql_fetch_array($q);
		$picture = $rows[0];
		if ($picture == "photos/default_male.png"){
			return "Male";
		}else if ($picture == "photos/default_female.png"){
			return "Female";
		}else return false;
	}
	
	//gets the picture update form
	public function updatePictureForm(){
		$button = isset($_POST["picture_submit"]) ? $_POST["picture_submit"] : "";//button
		$data = isset($_FILES["picture_select"]) ? $_FILES["picture_select"] : "";//image data
		?>
		<div class="change_picture_form_container">
			<h3>Change Picture:</h3>
			<form action="" method="post" enctype="multipart/form-data">
				<label for="picture_select">Picture:</label>
				<input type="file" name="picture_select" id="picture_select" value="<?php echo isset($data["name"]) ? $data["name"] : ""; ?>" />
				<br />
				<input type="submit" class="picture_submit" name="picture_submit" value="Change Picture" />
			</form>
			<?php echo $this->processPictureUpdate($button, $data); ?>
		</div>
		<?php
	}
	
	/* @param button - Change Picture button
	 * @param data - image uploaded data
	 * validates the image entered and processes to upload
	*/
	private function processPictureUpdate($button, $data){
		if ($button != ""){//if clicked the bn
			$name = $data["name"];//get file name
			$type = $data["type"];//get file type
			$tmp_name = $data["tmp_name"];//get temp name
			$error = $data["error"];//error
			$size = $data["size"];//its size
			//message we will be serving back to the user
			echo '<span class="message_error" style="display:inline-block;width:100%;margin-left:-6px;">';
			if ($name == ""){//if nothing was entered as picture
				echo 'Please select your picture.';//throw an error
			}else{//otherwise
				if ($this->isValidType($type)){//if image is a valid image type
					if ($size > $this->filesize){//if image filesize is not greater than our fixed size
						echo 'Picture must be 4mb maximum.';
					}else{
						if ($this->checkDimensions($tmp_name, 50, 50)){//if minimum dimensions are 50x50
							$this->proceedUpload($tmp_name);//upload it
							header("Location: /user_page.php?action=change_picture");//redirect
						}else
							echo 'Minimum picture dimensions are 50x50.';
					}
				}else
					echo 'Your picture is not a valid type.<br />(Allowed types are jpg,png and gif.)';
			}
			echo '</div>';
		}
	}
	
	/* @param filename - image name
	 * submits the image via the current width and height
	*/
	private function proceedUpload($filename){
		$image = new ResizePhoto();
		$data = $this->getDimensions($filename);//get image dimensions
		$width = $data[0];
		$height = $data[1];
		//upload depending the current image width and height
		if ($width > $this->max_width && $height > $this->max_height){
			$this->submitImage($filename, $width, $height, 1);
		}else if ($width > $this->max_width && $height <= $this->max_height){
			$this->submitImage($filename, $width, $height, 2);
		}else if ($width <= $this->max_width && $height > $this->max_height){
			$this->submitImage($filename, $width, $height, 3);
		}else{
			$this->submitImage($filename, $width, $height, 4);
		}
	}
	
	/* @param user_id - INT user id
	 * returns the current image name
	*/
	public function getCurrentImage($user_id){
		$q = mysql_query("SELECT picture FROM users WHERE user_id='$user_id'");
		$rows = mysql_fetch_array($q);
		return $rows[0];
	}
	
	/* @param filename VARCHAR - image name
	 * @param width VARCHAR - image width
	 * @param height VARCHAR - image height
	 * @param type INT - resize type
	*/
	private function submitImage($filename, $width, $height, $type){
		$misc = new Misc();
		$rand = $misc->generateId();//get random picture id
		$image_name = md5($rand);//md5 it
		$image_name = $this->base.$image_name.'.jpg';//save is as .jpg
		$flag = false;
		while ($flag == false){//if ID does not exist, continue , else find an ID that does not exist
			$q = mysql_query("SELECT * FROM users WHERE picture='$image_name'");
			$rows = mysql_num_rows($q);
			if ($rows){
				$rand = $misc->generateId();
				$image_name = md5($rand);
				$image_name = $this->base.$image_name.'.jpg';
			}else
				$flag = true;
		}
		if ($flag == true){
			$myid = $_SESSION["user_id"];
			$current_image = $this->getCurrentImage($myid);//get current image
			//if we are changing a picture and our current one is not the default one , delete the previous
			if ($current_image != "photos/default_male.png" && $current_image != "photos/default_female.png"){
				unlink($current_image);
			}
			//update picture
			mysql_query("UPDATE users SET picture='$image_name' WHERE user_id='$myid'");
			//save the image
			$this->saveImage($type, $filename, $width, $height, $image_name);
		}
	}
	
	/* @param type INT - resize type
	 * @param filename VARCHAR - image name
	 * @param width INT -  image width
	 * @param height INT - image height
	 * @param image_name VARCHAR - new image name
	*/
	private function saveImage($type=null, $filename, $width, $height, $image_name){
		$image = new ResizePhoto();
		if ($type == 1){//resize by width and height
			$image->load($filename);
			$image->resizeToHeight($this->max_height);
			$image->resizeToWidth($this->max_width);
			$image->save($image_name);	
		}else if ($type == 2){//resize by width
			$image->load($filename);
			$image->resizeToWidth($this->max_width);
			$image->save($image_name);
		}else if ($type == 3){//resize by height
			$image->load($filename);
			$image->resizeToWidth($width);
			$image->resizeToHeight($this->max_height);
			$image->save($image_name);
		}else if ($type == 4){//resize by fixed dimensions
			$image->load($filename);
			$image->resize($width,$height);
			$image->save($image_name);
		}
	}
	
	/* @param filename VARCHAR - image name
	 * returns images data information - ARRAY
	*/
	private function getDimensions($filename){
		$data = getimagesize($filename);
		return $data;
	}
	
	/* @param filename VARCHAR - image name
	 * @param check_width INT - the width we are checking against
	 * @param check_height INT - the height we are checking against
	 * returns BOOL
	*/
	private function checkDimensions($filename, $check_width, $check_height){
		$data = $this->getDimensions($filename);
		$width = $data[0];
		$height = $data[1];
		if ($width >= $check_width && $height >= $check_height){//if current width and height and not greater equal then our defined
			return true;
		}else return false;
	}
	
	/* @param type VARCHAR - image type
	 * checks if entered type is a valid type
	 * returns BOOL
	*/
	private function isValidType($type){
		$types = array(
			'image/jpeg',
			'image/png',
			'image/jpg',
			'image/gif',
			'image/pjpeg',
			'image/x-png'
		);
		if (in_array($type, $types)){
			return true;
		}else return false;
	}
	
}
?>