<?php
// www.p30vel.ir is the Best Publisher 
if(!empty($_SERVER['HTTP_X_REQUESTED_WITH']) && strtolower($_SERVER['HTTP_X_REQUESTED_WITH']) == 'xmlhttprequest') {	
	define("access", true);
	include_once 'classes/misc.class.php';
	include_once 'classes/email.class.php';
	include_once 'classes/activate.class.php';
	include_once 'classes/photos.class.php';
	$misc = new Misc();
	$photos = new Photos();
	include_once 'config.php';
	//no errors at start
	$error = false;
	//message to return and inputs with errors
	$message = $inputs_errors = $logged_in = $logged_out = '';
	//assign all variables that we get via the ajax requests
	$method = isset($_POST["method"]) ? $_POST["method"] : "";
	$username = isset($_POST["username"]) ? $_POST["username"] : "";
	$username_ue = isset($_POST["username_ue"]) ? $_POST["username_ue"] : "";
	$password = isset($_POST["password"]) ? $_POST["password"] : "";
	$firstname = isset($_POST["firstname"]) ? $_POST["firstname"] : "";
	$lastname = isset($_POST["lastname"]) ? $_POST["lastname"] : "";
	$current_password = isset($_POST["current_password"]) ? $_POST["current_password"] : "";
	$password1 = isset($_POST["password1"]) ? $_POST["password1"] : "";
	$password2 = isset($_POST["password2"]) ? $_POST["password2"] : "";
	$email = isset($_POST["email"]) ? $_POST["email"] : "";
	$email_ue = isset($_POST["email_ue"]) ? $_POST["email_ue"] : "";
	$gender = isset($_POST["gender"]) ? $_POST["gender"] : "";
	$activate_os = isset($_POST["activate_os"]) ? $_POST["activate_os"] : "";
	$code = isset($_POST["code"]) ? $_POST["code"] : "";
	//send json back
	$array = array(
		'error' => $error,
		'message' => $message,
		'inputs_errors' => $inputs_errors
	);
	//if user is not logged in
	if (!$misc->loggedIn()){
		//signing in
		if ($method == 'signin'){
			//include the Login class
			include_once 'classes/login.class.php';
			$array = array(
				'username' => $username,
				'password' => $password
			);
			$login = new Login($array);
			//log in the user
			$recieve_data = $login->LoginUser();
			//data got back from log in
			$error = $recieve_data["error"];
			$message = $recieve_data["message"];
			$inputs_errors = $recieve_data["inputs_errors"];
			$logged_in = $recieve_data["logged_in"];
			//send json back
			$array = array(
				'error' => $error,
				'message' => $message,
				'inputs_errors' => $inputs_errors,
				'logged_in' => $logged_in
			);
		}else if ($method == 'signup'){ //signing up
			//includes the register class
			include_once 'classes/register.class.php';
			$array = array(
				'username' => $username,
				'firstname' => $firstname,
				'lastname' => $lastname,
				'password1' => $password1,
				'password2' => $password2,
				'email' => $email,
				'gender' => $gender,
				'activate_os' => $activate_os
			);
			$register = new Register($array);
			//registers the user
			$recieve_data = $register->registerUser();
			//data got back from registration
			$error = $recieve_data["error"];
			$message = $recieve_data["message"];
			$inputs_errors = $recieve_data["inputs_errors"];
			//send json back
			$array = array(
				'error' => $error,
				'message' => $message,
				'inputs_errors' => $inputs_errors
			);
		}else if ($method == "activate_account"){
			//activating use account
			//include activate Class
			include_once 'classes/activate.class.php';
			$array = array(
				'email' => $email,
				'code' => $code
			);
			$activate = new Activate($email, $code);
			//activate user
			$recieve_data = $activate->activateUser();
			$error = $recieve_data["error"];
			$message = $recieve_data["message"];
			$inputs_errors = $recieve_data["inputs_errors"];
			//send json back
			$array = array(
				'error' => $error,
				'message' => $message,
				'inputs_errors' => $inputs_errors
			);
		}else if ($method == "resent_activation_code"){
			//resenting user activation code
			//including the appropriate library
			include_once 'classes/activate.class.php';
			$array = array(
				'email' => $email
			);
			$activate = new Activate($email, null);
			//send the new code
			$recieve_data = $activate->resentActivationCode();
			//get back the appropriate data
			$error = $recieve_data["error"];
			$message = $recieve_data["message"];
			$inputs_errors = $recieve_data["inputs_errors"];
			//send json back
			$array = array(
				'error' => $error,
				'message' => $message,
				'inputs_errors' => $inputs_errors
			);
		}else if ($method == 'recover_password'){ //recover password
			//include recover password library
			include_once 'classes/recover_password.class.php';
			$recover = new Recover_Password($email);
			//send recover email to the user
			$recieve_data = $recover->sendRecoverEmail();
			//get back data from recover system
			$error = $recieve_data["error"];
			$message = $recieve_data["message"];
			$inputs_errors = $recieve_data["inputs_errors"];
			//send json back
			$array = array(
				'error' => $error,
				'message' => $message,
				'inputs_errors' => $inputs_errors
			);
		}else{
			//every other method cannot go any further than getting an error.
			$error = true;
			$message = 'Could not complete the request.';
		}
	}else{
		//for logged in users
		//They are log out and update their user settings
		if ($method == "logout"){
			//logout method
			//include logout class
			include_once 'classes/logout.class.php';
			$logout = new Logout();
			//logout user
			$logout->logoutUser();
			//we use this BOOL to redirect the user when the ajax request finishes
			$logged_out = true;
			//send json back
			$array = array(
				'error' => $error,
				'message' => $message,
				'inputs_errors' => $inputs_errors,
				'logged_out' => $logged_out
			);
		}else if ($method == 'update_settings'){
			//updating user settings
			//include the library
			include_once 'classes/change_settings.class.php';
			//send the array with the user data
			$array = array(
				'username' => $username,
				'firstname' => $firstname,
				'lastname' => $lastname,
				'current_password' => $current_password,
				'password1' => $password1,
				'password2' => $password2,
				'email' => $email,
				'gender' => $gender
			);
			$cs = new ChangeSettings($array);
			//update user Settings
			$recieve_data = $cs->updateSettings();
			$error = $recieve_data["error"];
			$message = $recieve_data["message"];
			$inputs_errors = $recieve_data["inputs_errors"];
			$picture = $photos->getCurrentImage($_SESSION["user_id"]);
			//send json back
			$array = array(
				'error' => $error,
				'message' => $message,
				'inputs_errors' => $inputs_errors,
				'picture' => $picture
			);
		}else
			$message = 'Please log in to use these features.';//simple message when a user tries to do ajax requests when logged in and its not a logout or update settings method
	}
	if ($method == "admin_update_settings"){//changing user settings when logging in as admin
		if (isset($_SESSION["logged_as_admin"])){
			//updating user settings
			//include the library
			include_once 'classes/change_settings.class.php';
			//send the array with the user data
			$array = array(
				'username' => $username,
				'username_ue' => $username_ue,
				'firstname' => $firstname,
				'lastname' => $lastname,
				'password1' => $password1,
				'password2' => $password2,
				'email' => $email,
				'email_ue' => $email_ue,
				'gender' => $gender
			);
			$cs = new ChangeSettings($array);
			//update user Settings
			$recieve_data = $cs->AdminUpdateSettings();
			$error = $recieve_data["error"];
			$message = $recieve_data["message"];
			$inputs_errors = $recieve_data["inputs_errors"];
			//send json back
			$array = array(
				'error' => $error,
				'message' => $message,
				'inputs_errors' => $inputs_errors
			);
		}
	}
	//headers for JSON
	header('Content-type: application/json');
	//encode the array that we sent back
	echo json_encode($array);
}else die();
?>