<?php
// www.p30vel.ir is the Best Publisher 
if(!defined("access")){die();}
Class UserInterface{
	
	/* Contains the main navigation menu that a guest see.
	 * It also contains the buttons that trigger the popup window
	*/
	public function getNavigationTopMenu(){
		$misc = new Misc();
		if (!$misc->loggedin()){
			?>
			<label class="actions_header_title">Welcome Guest, You may...</label><br />
			<div class="signin_popup_button" id="sign_in" title="Sign in">Sign In</div>
			<div class="signup_popup_button" id="sign_up" title="Sign up">Sign Up</div>
			<div class="recoverpass_popup_button" id="recoverpass" title="Recover Password">Recover Password</div>
			<div class="activate_account_popup_button" id="activate_account" title="Activate Account">Activate Account</div>
			<?php
		}else{
			?>
			<label class="actions_header_title">Welcome back, <?php echo $_SESSION["username"].'.</label> &raquo; <a href="/user_page.php" class="link">View your Page</a> &bull; <a href="#" id="logout_button">Logout</a>'; ?><br />
			<?php
		}
	}
	
	public function getUserInterface($user_page=null, $action){
		$misc = new Misc();
		?>
		<div id="bg_color"></div>
		<div style="text-align: center;">
			<div id="user_controls">
			<?php
				//if we are not logged in - show the Navigation menu
				
				if ($user_page == 1){
					//otherwise show the user page
					$this->getUserPage($action);
				}else
					$this->getNavigationTopMenu();
					
					
			?>
			</div>
		</div>
		<?php
		//if not logged in allow the popup to show.
		if (!$misc->loggedIn()){
			//show the popup window
			$this->getPopupContainer();
		}
	}
	
	/* Contains all Popup Window Pages
	*/
	public function getPopupContainer(){
		?>
		<div id="popup_window">
			<div class="loader"><img src="loading.gif" style="border:0;" alt="loading" />Loading...</div>
			<div class="popup_content_data">
				<span class="popup_window_close" title="Close Popup"></span>
				<h1 class="popup_header_title"></h1>
				<div class="popup_content_sign_in">
					<label for="username_input_signin">
						Username:
					</label>
					<input type="text" id="username_input_signin" />
					<br />
					<label for="password_input_signin">
						Password:
					</label>
					<input type="password" id="password_input_signin" />
					<br />
					<div id="signin_submit">Sign in</div>
					<div class="message_error"></div>
				</div>
				<div class="popup_content_sign_up">
					<label for="username_input_signup">
						Username:
					</label>
					<input type="text" id="username_input_signup" />
					<br />
					<label for="firstname_input_signup">
						Firstname:
					</label>
					<input type="text" id="firstname_input_signup" />
					<br />
					<label for="lastname_input_signup">
						Lastname:
					</label>
					<input type="text" id="lastname_input_signup" />
					<br />
					<label for="password_input_signup">
						Password:
					</label>
					<input type="password" id="password_input_signup" />
					<br />
					<label for="retype_password_input_signup">
						Re-type Password:
					</label>
					<input type="password" id="retype_password_input_signup" />
					<br />
					<label for="email_input_signup">
						Email:
					</label>
					<input type="text" id="email_input_signup" />
					<br />
					<label for="gender_input_signup">
						Gender:
					</label>
					<select name="gender_input_signup" id="gender_input_signup">
						<option name="0">Select Gender:</option>
						<option name="1">Male</option>
						<option name="2">Female</option>
					</select>
					<br />
					<div id="signup_submit">Sign up</div><br />
					<div class="message_error"></div>
				</div>
				<div class="popup_content_recoverpass">
					<label for="email_input_recpass">
						Email:
					</label>
					<input type="text" id="email_input_recpass" />
					<br />
					<div id="recoverpass_submit">Recover Password</div>
					<div class="message_error"></div>
				</div>
				<div class="popup_content_activate_account">
					<label for="email_input_activateacc">
						Email:
					</label>
					<input type="text" id="email_input_activateaccount" />
					<br />
					<label for="code_input_activateaccount">
						Code:
					</label>
					<input type="text" id="code_input_activateaccount" />
					<br />
					<div id="activateaccount_submit">Activate Account</div>
					<div class="message_error"></div>
				</div>
				<div class="popup_content_resent_activation_code">
					<label for="email_input_resent_activation_code">
						Email:
					</label>
					<input type="text" id="email_input_resent_activation_code" />
					<br />
					<div id="resent_activation_code_submit">Resent Code</div>
					<div class="message_error"></div>
				</div>
				<div class="popup_right_message">
					<div class="message_row">
						Not have an account?<br />
						<div class="switch_popup_signup_button" title="Switch to Sign up Page" id="sign_up">Sign up</div><br />
					</div>	
					<hr />
					<div class="message_row">
						Already registered?<br />
						<div class="switch_popup_signin_button" title="Switch to Sign in Page" id="sign_in">Sign in</div>
					</div>
					<hr />
					<div class="message_row">
						Forgot your password?<br />
						<div class="switch_popup_recover_pass_button" title="Switch to Forgor your password Page" id="recoverpass">Recover Password</div>
					</div>	
					<hr />
					<div class="message_row">
						Activate Account?<br />
						<div class="switch_popup_new_activation_code_button" title="Switch to Activate Account Page" id="activate_account">Activate Account</div>
					</div>
					<hr />
					<div class="message_row">
						Lost activation code?<br />
						<div class="switch_popup_resent_activation_code_button" title="Switch to Resent activate Code Page" id="resent_activation_code">Resent activation Code</div>
					</div>
				</div>
			</div>
		</div>
		<?php
	}
	
	/* Gets the user Page when logged in
	*/
	public function getUserPage($action){
		$misc = new Misc();
		$photos = new Photos();
		if ($misc->loggedIn()){
			$data = $misc->getUserData($_SESSION["username"]);
			?>
			<h1><?php echo $data["firstname"].' '.$data["lastname"].'('.$data["username"].')'; ?></h1><br />
			<img src="<?php echo $data["avatar"]; ?>" class="user_avatar" /> &rarr; <a href="?action=change_picture" class="link">Edit Picture</a> &bull; <a href="user_page.php" class="link">Home</a>
			<?php
			if ($action == "")
			{
				?>
					<span class="user_details_header">These are your account details &darr;<a href="#" id="logout_button" style="float:right;">Logout</a></span><br />
					<div class="user_profile_details">
						<label for="user_settings_username">Username</label><input type="text" value="<?php echo $data["username"]; ?>" id="user_settings_username" /><br />
						<label for="user_settings_firstname">Firstname</label><input type="text" value="<?php echo $data["firstname"]; ?>" id="user_settings_firstname" /><br />
						<label for="user_settings_lastname">Lastname</label><input type="text" value="<?php echo $data["lastname"]; ?>" id="user_settings_lastname" /><br />
						<label for="user_settings_current_password">Current Password</label><input type="password" value="" id="user_settings_current_password" /><br />
						<label for="user_settings_password">Password</label><input type="password" value="" id="user_settings_password" /><br />
						<label for="user_settings_retype_password">Retype Password</label><input type="password" value="" id="user_settings_retype_password" /><br />
						<label for="user_settings_email">Email</label><input type="text" value="<?php echo $data["email"]; ?>" id="user_settings_email" /><br />
						<label for="user_settings_gender">Gender</label>
						<select name="user_settings_gender" id="user_settings_gender">
							<option name="0">Select Gender:</option>
							<option name="1" <?php echo ($data["gender"] == 1) ? 'selected="selected"' : ''; ?>>Male</option>
							<option name="2" <?php echo ($data["gender"] == 2) ? 'selected="selected"' : ''; ?>>Female</option>
						</select><br />
						<div id="update_user_settings">Update</div>
						<div class="message_error"></div>
					</div>
				<?php
			}else if ($action == "change_picture"){
				$photos->updatePictureForm();
			}else
				echo '<span class="message_error" style="display:inline-block;">Page not found.</span>';
		}
	}
	
	//get admin user change page
	public function getAdminAccountEditForm($username){
		$misc = new Misc();
		if (isset($_SESSION["logged_as_admin"])){//if isset admin session
			$data = $misc->getUserData($username);
			?>
			<div id="user_controls">
				<div class="user_profile_details">
					<h2 style="border-bottom:1px solid #CCC;padding-bottom:5px;margin-bottom:5px;">User Account Edit</h2>
					<label for="user_settings_username">Username</label><input type="text" value="<?php echo $data["username"]; ?>" id="user_settings_username" /><br />
					<label for="user_settings_firstname">Firstname</label><input type="text" value="<?php echo $data["firstname"]; ?>" id="user_settings_firstname" /><br />
					<label for="user_settings_lastname">Lastname</label><input type="text" value="<?php echo $data["lastname"]; ?>" id="user_settings_lastname" /><br />
					<label for="user_settings_password">Password</label><input type="password" value="" id="user_settings_password" /><br />
					<label for="user_settings_retype_password">Retype Password</label><input type="password" value="" id="user_settings_retype_password" /><br />
					<label for="user_settings_email">Email</label><input type="text" value="<?php echo $data["email"]; ?>" id="user_settings_email" /><br />
					<label for="user_settings_gender">Gender</label>
					<select name="user_settings_gender" id="user_settings_gender">
						<option name="0">Select Gender:</option>
						<option name="1" <?php echo ($data["gender"] == 1) ? 'selected="selected"' : ''; ?>>Male</option>
						<option name="2" <?php echo ($data["gender"] == 2) ? 'selected="selected"' : ''; ?>>Female</option>
					</select><br />
					<div class="admin_update_user_settings">Update</div>
					<input type="hidden" id="u_un_ue" value="<?php echo $data["username"]; ?>" />
					<input type="hidden" id="u_em_ue" value="<?php echo $data["email"]; ?>" />
					<div class="message_error" style="width:98%;"></div>
				</div>
			</div>
			<?php
		}
	}
	
	//get admin new account form
	public function getAdminNewAccountForm(){
		?>
		<div class="popup_content_sign_up" style="display:inline-block;margin-left:280px;">
			<label for="username_input_signup">
				Username:
			</label>
			<input type="text" id="username_input_signup" />
			<br />
			<label for="firstname_input_signup">
				Firstname:
			</label>
			<input type="text" id="firstname_input_signup" />
			<br />
			<label for="lastname_input_signup">
				Lastname:
			</label>
			<input type="text" id="lastname_input_signup" />
			<br />
			<label for="password_input_signup">
				Password:
			</label>
			<input type="password" id="password_input_signup" />
			<br />
			<label for="retype_password_input_signup">
				Re-type Password:
			</label>
			<input type="password" id="retype_password_input_signup" />
			<br />
			<label for="email_input_signup">
				Email:
			</label>
			<input type="text" id="email_input_signup" />
			<br />
			<label for="gender_input_signup">
				Gender:
			</label>
			<select name="gender_input_signup" id="gender_input_signup">
				<option name="0">Select Gender:</option>
				<option name="1">Male</option>
				<option name="2">Female</option>
			</select>
			<br /><br />
			<label for="activate_onsignup">
				Activate account on signup?
			</label>
			<input type="checkbox" id="activate_onsignup" />
			<br />
			<div id="signup_submit">Sign up</div><br />
			<div class="message_error"></div>
		</div>
		<?php
	}

}
?>