<?php
// www.p30vel.ir is the Best Publisher 
Class Recover_Password{
	
	//email to recover its password
	private $email;
	
	//errors we will be showing to the user
	private $error = '';
	//which field have errors so they get a red border
	private $error_fields = '';
	
	//hash of recover
	private $hash;
	
	//initialize the email variable
	function __construct($email){
		$misc = new Misc();
		//escape and trim the email
		$this->email = $misc->escapeValue($misc->trimValue($email));
	}
	
	/* requires user email
	 * removes any record for this particular use
	*/
	private function removePreviousRecovers(){
		mysql_query("DELETE FROM recover WHERE recover_email='$this->email'");
	}
	
	/* requires user email and hash
	 * inserts a new recover password record
	*/
	private function addNewRecord(){
		//get random hash id and md5 it
		$this->hash = md5(rand(0000000, 9999999));
		//insert record
		mysql_query("INSERT INTO recover VALUES ('', '$this->email', '$this->hash')");
	}
	
	/* Procedure that checks the given email and sends recover email or returns errors
	*/
	private function proccessEmail(){
		$misc = new Misc();
		$email = new Email();
		//if email is not empty
		if ($this->email != ""){
			//validate email address
			if(preg_match( "/^[\d\w\/+!=#|$?%{^&}*`'~-][\d\w\/\.+!=#|$?%{^&}*`'~-]*@[A-Z0-9][A-Z0-9.-]{1,61}[A-Z0-9]\.[A-Z]{2,6}$/ix", $this->email ) == 1){
				$this->email = ($this->email);
				//if email exist in our system
				if ($misc->emailExist($this->email)){
					//remove if the user had tried to recover the password some time else
					$this->removePreviousRecovers();
					//add new record for that user
					$this->addNewRecord();
					
					//subject of the email
					$subject = 'Reset password';
					//body of the email
					$reciever_message = "User $this->email\n\n you have sent us a request for your password...\n\n\n\n";
					$reciever_message .= "Please go to http://domain.com/reset.php?email=$this->email&hash=$this->hash to reset your password";
					//send email
					$email->sendEmail($this->email, $misc->sender_email, $subject, $reciever_message);
				}else{
					$this->error .= '<li>This email address does not exist in our system.</li>';
					$this->error_fields .= 'email';
				}
			}else{
				$this->error .= '<li>Please enter a valid email address.</li>';
				$this->error_fields .= 'email';
			}
		}else{
			//all fields are blank, tell the user to fill them.
			$this->error .= '<li>Please fill in the email.</li>';
			//red marked fields
			$this->error_fields .= 'email';
		}
		
		if ($this->error == ""){
			//send user a message that an email has been sent
			$array = array(
				'error' => false,
				'message' => 'An email has been sent to your email address to recover your password.',
				'inputs_errors' => ''
			);
		}else{
			//else send the errors
			$array = array(
				'error' => true,
				'message' => '<ul style="padding:0;margin:0;margin-left:15px;">'.$this->error.'</ul>',
				'inputs_errors' => $this->error_fields
			);
		}
		return $array;
	}
	
	/* Sents user an email
	*/
	public function sendRecoverEmail(){
		return $this->proccessEmail();
	}
	
}
?>